using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_Inventarios._0_Modelos;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Inventarios._1_Datos
{
    public class INV_MovimientosAlmacenCabecera_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo> g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(INV_MovimientosAlmacenCabecera).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo != null) && (g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Count() > 0))
                {
                    lst_MAE = g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_MAE;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(INV_MovimientosAlmacenCabecera).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo != null) && (g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Count() > 0))
                {
                    dnm_MAE = g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                bool bol_FiltrarEjercicio = false;
                DateTime? dtt_TemporadaInicio = null;
                DateTime? dtt_TemporadaFin = null;

                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    foreach (INTERNO_Filtro_OpcionPadre_Modelo mdl_INTERNO_Filtro_OpcionPadre_Modelo in _lst_INTERNO_Filtro_OpcionPadre_Modelo)
                    {
                        //Ejercicio
                        if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO.Equals(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.idEjercicio)))
                        {
                            //Buscar el Modelo de Ejercicio
                            GEN_EjerciciosActivos_Empresa mdl_GEN_EjerciciosActivos_Empresa = Datos_Generales.GEN_EjerciciosActivos_Empresa_Obtener_Por_Id(mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR);

                            if (mdl_GEN_EjerciciosActivos_Empresa != null)
                            {
                                bol_FiltrarEjercicio = true;
                                dtt_TemporadaInicio = mdl_GEN_EjerciciosActivos_Empresa.temporadaFechaInicio;
                                dtt_TemporadaFin = mdl_GEN_EjerciciosActivos_Empresa.temporadaFechaFin;
                            }
                        }
                    }
                }

                string str_SQL =
                 " SELECT " +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.id) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.id) + "," +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.idEmpleado) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idEmpleado) + "," +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.numeroDocumento) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.numeroDocumento) + "," +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.fecha) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fecha) + "," +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.estado) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.estado) + "," +
                     //ids
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.idEmpresa) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idEmpresa) + "," +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.idDelegacion_Origen) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Origen) + "," +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.idDelegacion_Destino) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Destino) + "," +
                     //Empresa
                     (
                          (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa)))
                              ?
                                  (
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa_Codigo) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.codigo) + "," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa_Descripcion) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.descripcion) + "," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa_FechaBorrado) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.fechaBorrado) + ","
                                  )
                              :
                                  (
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa_Codigo) + " = ''," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa_Descripcion) + " = ''," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa_FechaBorrado) + " = NULL ,"
                                  )
                     ) +
                     //Delegacion origen
                     (
                          (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen)))
                              ?
                                  (
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen_Codigo) + " = " + nameof(GEN_Delegaciones) + "_Origen." + nameof(GEN_Delegaciones.codigo) + "," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen_Descripcion) + " = " + nameof(GEN_Delegaciones) + "_Origen." + nameof(GEN_Delegaciones.descripcion) + "," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen_FechaBorrado) + " = " + nameof(GEN_Delegaciones) + "_Origen." + nameof(GEN_Delegaciones.fechaBorrado) + ","
                                  )
                              :
                                  (
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen_Codigo) + " = ''," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen_Descripcion) + " = ''," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen_FechaBorrado) + " = NULL ,"
                                  )
                     ) +
                     //Delegacion destino
                     (
                          (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino)))
                              ?
                                  (
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino_Codigo) + " = " + nameof(GEN_Delegaciones) + "_Destino." + nameof(GEN_Delegaciones.codigo) + "," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino_Descripcion) + " = " + nameof(GEN_Delegaciones) + "_Destino." + nameof(GEN_Delegaciones.descripcion) + "," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino_FechaBorrado) + " = " + nameof(GEN_Delegaciones) + "_Destino." + nameof(GEN_Delegaciones.fechaBorrado)
                                  )
                              :
                                  (
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino_Codigo) + " = ''," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino_Descripcion) + " = ''," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino_FechaBorrado) + " = NULL "
                                  )
                     ) +
                     " FROM " + nameof(INV_MovimientosAlmacenCabecera) +
                     //Empresa
                     (
                         (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa)))
                         ?
                             (
                                     " LEFT JOIN " + nameof(GEN_Empresas) + " ON " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idEmpresa) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.id)
                             )
                         : ("")
                     ) +
                     //Delegacion origen
                     (
                         (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen)))
                         ?
                             (
                                     " LEFT JOIN " + nameof(GEN_Delegaciones) + " as " + nameof(GEN_Delegaciones) + "_Origen ON " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Origen) + " = " + nameof(GEN_Delegaciones) + "_Origen." + nameof(GEN_Delegaciones.id)
                             )
                         : ("")
                     ) +
                     //Delegacion destino
                     (
                         (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino)))
                         ?
                             (
                                     " LEFT JOIN " + nameof(GEN_Delegaciones) + " as " + nameof(GEN_Delegaciones) + "_Destino ON " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Destino) + " = " + nameof(GEN_Delegaciones) + "_Destino." + nameof(GEN_Delegaciones.id)
                             )
                         : ("")
                     ) +
                     " WHERE " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fechaBorrado) + " IS null AND " +
                                 (_lng_id > -1 ? nameof(INV_MovimientosAlmacenCabecera) + "." + (nameof(INV_MovimientosAlmacenCabecera.id) + "=@id") : "1 = 1") + " AND " +
                                 //Ejercicio
                                 " ( " +
                                     (
                                         bol_FiltrarEjercicio == true
                                             ? (nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fecha) + " <=@TemporadaFin AND " +
                                                  nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fecha) + " >=@TemporadaInicio ")
                                             : " 1 = 1 "
                                     ) +
                                 " ) ";


                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                lst_Parametros.Add(new SqlParameter("@id", _lng_id));

                if (bol_FiltrarEjercicio)
                {
                    lst_Parametros.Add(new SqlParameter("@TemporadaFin", dtt_TemporadaFin));
                    lst_Parametros.Add(new SqlParameter("@TemporadaInicio", dtt_TemporadaInicio));
                }
                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

                //Añadir los Ejercicios
                if (g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo != null && g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Count > 0)
                {
                    Agregar_Ejercicios(_lng_idEmpresaSeleccionada);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        private void Agregar_Ejercicios(long _lng_idEmpresaSeleccionada)
        {
            try
            {
                List<GEN_EjerciciosActivos_Empresa> lst_GEN_EjerciciosActivos_Empresa = Datos_Generales.GEN_EjerciciosActivos_Empresa_Obtener_Listado_Por_Empresa(_lng_idEmpresaSeleccionada);

                if (lst_GEN_EjerciciosActivos_Empresa != null)
                {
                    //Rellenar el Listado
                    foreach (INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo mdl_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo in g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo)
                    {
                        mdl_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Ejercicios_Empresa = lst_GEN_EjerciciosActivos_Empresa.Where(m => m.temporadaFechaFin >= mdl_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.fecha &&
                                                                                                                                            m.temporadaFechaInicio <= mdl_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.fecha)
                                                                                                                              .FirstOrDefault();
                    }
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Agregar_Ejercicios), true);
            }
        }
        #endregion

        #region Listado Secundario
        private List<INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo> g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo_LISTADOSECUNDARIO = null;
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_INV = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado_Secundario(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(INV_MovimientosAlmacenCabecera).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo_LISTADOSECUNDARIO != null) && (g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo_LISTADOSECUNDARIO.Count() > 0))
                {
                    lst_INV = g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo_LISTADOSECUNDARIO.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_INV;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_INV = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado_Secundario(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(INV_MovimientosAlmacenCabecera).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo_LISTADOSECUNDARIO != null) && (g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo_LISTADOSECUNDARIO.Count() > 0))
                {
                    dnm_INV = g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo_LISTADOSECUNDARIO.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_INV;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(INV_MovimientosAlmacenCabecera),
                                                                                        nameof(INV_MovimientosAlmacenCabecera.id),
                                                                                        G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.AND_FIN,
                                                                                        _lst_ids);

                bool bol_FiltrarEjercicio = false;
                DateTime? dtt_TemporadaInicio = null;
                DateTime? dtt_TemporadaFin = null;

                long lng_idArticulo = -1;
                string str_Opcion_Articulo = "";

                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    foreach (INTERNO_Filtro_OpcionPadre_Modelo mdl_INTERNO_Filtro_OpcionPadre_Modelo in _lst_INTERNO_Filtro_OpcionPadre_Modelo)
                    {
                        //Ejercicio
                        if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO.Equals(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.idEjercicio)))
                        {
                            //Buscar el Modelo de Ejercicio
                            GEN_EjerciciosActivos_Empresa mdl_GEN_EjerciciosActivos_Empresa = Datos_Generales.GEN_EjerciciosActivos_Empresa_Obtener_Por_Id(mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR);

                            if (mdl_GEN_EjerciciosActivos_Empresa != null)
                            {
                                bol_FiltrarEjercicio = true;
                                dtt_TemporadaInicio = mdl_GEN_EjerciciosActivos_Empresa.temporadaFechaInicio;
                                dtt_TemporadaFin = mdl_GEN_EjerciciosActivos_Empresa.temporadaFechaFin;
                            }
                        }
                        //ARTICULO
                        else if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO.Equals(Variables.G_STR_OPCION_MAE_ARTICULO))
                        {
                            lng_idArticulo = mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR;
                            str_Opcion_Articulo = mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO;
                        }
                    }
                }

                #region Articulo
                List<long> lst_idsMovimientoAlmacenCabecera_PorArticulo = null;
                if (lng_idArticulo > -1)
                {
                    INV_MovimientosAlmacenLineas_Datos obj_INV_MovimientosAlmacenLineas_Datos = new INV_MovimientosAlmacenLineas_Datos();
                    lst_idsMovimientoAlmacenCabecera_PorArticulo = obj_INV_MovimientosAlmacenLineas_Datos.Obtener_IdsMovimientoAlmacenCabecera_PorIdArticulo(lng_idArticulo);
                }
                string str_Filtro_PorArticulo = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(INV_MovimientosAlmacenCabecera),
                                                                                                        nameof(INV_MovimientosAlmacenCabecera.id),
                                                                                                        G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                                        lst_idsMovimientoAlmacenCabecera_PorArticulo);
                #endregion


                string str_SQL =
                 " SELECT " +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.id) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.id) + "," +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.idEmpleado) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idEmpleado) + "," +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.numeroDocumento) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.numeroDocumento) + "," +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.fecha) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fecha) + "," +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.estado) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.estado) + "," +
                     //ids
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.idEmpresa) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idEmpresa) + "," +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.idDelegacion_Origen) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Origen) + "," +
                     nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.idDelegacion_Destino) + " = " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Destino) + "," +
                     //Empresa
                     (
                          (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa)))
                              ?
                                  (
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa_Codigo) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.codigo) + "," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa_Descripcion) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.descripcion) + "," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa_FechaBorrado) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.fechaBorrado) + ","
                                  )
                              :
                                  (
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa_Codigo) + " = ''," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa_Descripcion) + " = ''," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa_FechaBorrado) + " = NULL ,"
                                  )
                     ) +
                     //Delegacion origen
                     (
                          (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen)))
                              ?
                                  (
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen_Codigo) + " = " + nameof(GEN_Delegaciones) + "_Origen." + nameof(GEN_Delegaciones.codigo) + "," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen_Descripcion) + " = " + nameof(GEN_Delegaciones) + "_Origen." + nameof(GEN_Delegaciones.descripcion) + "," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen_FechaBorrado) + " = " + nameof(GEN_Delegaciones) + "_Origen." + nameof(GEN_Delegaciones.fechaBorrado) + ","
                                  )
                              :
                                  (
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen_Codigo) + " = ''," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen_Descripcion) + " = ''," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen_FechaBorrado) + " = NULL ,"
                                  )
                     ) +
                     //Delegacion destino
                     (
                          (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino)))
                              ?
                                  (
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino_Codigo) + " = " + nameof(GEN_Delegaciones) + "_Destino." + nameof(GEN_Delegaciones.codigo) + "," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino_Descripcion) + " = " + nameof(GEN_Delegaciones) + "_Destino." + nameof(GEN_Delegaciones.descripcion) + "," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino_FechaBorrado) + " = " + nameof(GEN_Delegaciones) + "_Destino." + nameof(GEN_Delegaciones.fechaBorrado)
                                  )
                              :
                                  (
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino_Codigo) + " = ''," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino_Descripcion) + " = ''," +
                                      nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino_FechaBorrado) + " = NULL "
                                  )
                     ) +
                     " FROM " + nameof(INV_MovimientosAlmacenCabecera) +
                     //Empresa
                     (
                         (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Empresa)))
                         ?
                             (
                                     " LEFT JOIN " + nameof(GEN_Empresas) + " ON " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idEmpresa) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.id)
                             )
                         : ("")
                     ) +
                     //Delegacion origen
                     (
                         (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionOrigen)))
                         ?
                             (
                                     " LEFT JOIN " + nameof(GEN_Delegaciones) + " as " + nameof(GEN_Delegaciones) + "_Origen ON " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Origen) + " = " + nameof(GEN_Delegaciones) + "_Origen." + nameof(GEN_Delegaciones.id)
                             )
                         : ("")
                     ) +
                     //Delegacion destino
                     (
                         (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.DelegacionDestino)))
                         ?
                             (
                                     " LEFT JOIN " + nameof(GEN_Delegaciones) + " as " + nameof(GEN_Delegaciones) + "_Destino ON " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Destino) + " = " + nameof(GEN_Delegaciones) + "_Destino." + nameof(GEN_Delegaciones.id)
                             )
                         : ("")
                     ) +
                     " WHERE " +
                                //fechaBorrado
                                nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fechaBorrado) + " IS null AND " +
                                 //id
                                 (_lng_id > -1 ? nameof(INV_MovimientosAlmacenCabecera) + "." + (nameof(INV_MovimientosAlmacenCabecera.id) + "=@id") : "1 = 1") + " AND " +
                                //ids
                                str_Filtro_IDS +
                                //por Articulo
                                " ( " +
                                    (
                                        (str_Opcion_Articulo != "")
                                            ? (lst_idsMovimientoAlmacenCabecera_PorArticulo != null && lst_idsMovimientoAlmacenCabecera_PorArticulo.Count > 0)
                                                ? str_Filtro_PorArticulo
                                                : " 1 <> 1 "
                                            : " 1 = 1 "
                                    ) +
                               " ) AND " +
                                 //Ejercicio
                                 " ( " +
                                     (
                                         bol_FiltrarEjercicio == true
                                             ? (nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fecha) + " <=@TemporadaFin AND " +
                                                  nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fecha) + " >=@TemporadaInicio ")
                                             : " 1 = 1 "
                                     ) +
                                 " ) ";


                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                lst_Parametros.Add(new SqlParameter("@id", _lng_id));

                if (bol_FiltrarEjercicio)
                {
                    lst_Parametros.Add(new SqlParameter("@TemporadaFin", dtt_TemporadaFin));
                    lst_Parametros.Add(new SqlParameter("@TemporadaInicio", dtt_TemporadaInicio));
                }
                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo_LISTADOSECUNDARIO = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

                //Añadir los Ejercicios
                if (g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo_LISTADOSECUNDARIO != null && g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo_LISTADOSECUNDARIO.Count > 0)
                {
                    Agregar_Ejercicios_ListadoSecundario(_lng_idEmpresaSeleccionada);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(ConsultaRellenar_Listado_Secundario), true);
            }

        }
        private void Agregar_Ejercicios_ListadoSecundario(long _lng_idEmpresaSeleccionada)
        {
            try
            {
                List<GEN_EjerciciosActivos_Empresa> lst_GEN_EjerciciosActivos_Empresa = Datos_Generales.GEN_EjerciciosActivos_Empresa_Obtener_Listado_Por_Empresa(_lng_idEmpresaSeleccionada);

                if (lst_GEN_EjerciciosActivos_Empresa != null)
                {
                    //Rellenar el Listado
                    foreach (INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo mdl_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo in g_lst_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo_LISTADOSECUNDARIO)
                    {
                        mdl_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.Ejercicios_Empresa = lst_GEN_EjerciciosActivos_Empresa.Where(m => m.temporadaFechaFin >= mdl_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.fecha &&
                                                                                                                                            m.temporadaFechaInicio <= mdl_INTERNO_INV_MovimientosAlmacenCabecera_Listado_Modelo.fecha)
                                                                                                                              .FirstOrDefault();
                    }
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Agregar_Ejercicios_ListadoSecundario), true);
            }
        }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 4;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                         " SELECT " +
                             nameof(INTERNO_INV_MovimientosAlmacenCabecera_Modelo.id) + "=" + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.id) + "," +
                             nameof(INTERNO_INV_MovimientosAlmacenCabecera_Modelo.idEmpleado) + "=" + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idEmpleado) + "," +
                             nameof(INTERNO_INV_MovimientosAlmacenCabecera_Modelo.numeroDocumento) + "=" + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.numeroDocumento) + "," +
                             nameof(INTERNO_INV_MovimientosAlmacenCabecera_Modelo.observaciones) + "=" + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.observaciones) + "," +
                             nameof(INTERNO_INV_MovimientosAlmacenCabecera_Modelo.idDelegacion_Origen) + "=" + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Origen) + "," +
                             nameof(INTERNO_INV_MovimientosAlmacenCabecera_Modelo.idDelegacion_Destino) + "=" + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Destino) + "," +
                             nameof(INTERNO_INV_MovimientosAlmacenCabecera_Modelo.idEmpresa) + "=" + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idEmpresa) + "," +
                             nameof(INTERNO_INV_MovimientosAlmacenCabecera_Modelo.fecha) + "=" + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fecha) + "," +
                             nameof(INTERNO_INV_MovimientosAlmacenCabecera_Modelo.estado) + "=" + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.estado) + "," +
                             nameof(INTERNO_INV_MovimientosAlmacenCabecera_Modelo.guid) + "=" + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.guid) + "," +
                             nameof(INTERNO_INV_MovimientosAlmacenCabecera_Modelo.fechaBorrado) + "=" + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fechaBorrado) +
                        " FROM " + nameof(INV_MovimientosAlmacenCabecera) +
                        " WHERE  " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fechaBorrado) + " IS null AND " +
                                     nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<INTERNO_INV_MovimientosAlmacenCabecera_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar Tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //MAE_Empledo ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idEmpleado != null)
                    {
                        ThreadStart obj_ThreadStart_EMPLEADO = new ThreadStart(Obtener_Empleado_Modelo_Obtener);
                        Thread obj_Thread_EMPLEADO = new Thread(obj_ThreadStart_EMPLEADO);
                        obj_Thread_EMPLEADO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //GEN_Delegacion(Origen) ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idDelegacion_Origen != null)
                    {
                        ThreadStart obj_ThreadStart_DELEGACION = new ThreadStart(Obtener_Delegacion_ORIGEN_Modelo_Obtener);
                        Thread obj_Thread_DELEGACION = new Thread(obj_ThreadStart_DELEGACION);
                        obj_Thread_DELEGACION.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[1] = true;
                    }

                    //GEN_Delegacion(Destino) ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idDelegacion_Destino != null)
                    {
                        ThreadStart obj_ThreadStart_DELEGACION = new ThreadStart(Obtener_Delegacion_DESTINO_Modelo_Obtener);
                        Thread obj_Thread_DELEGACION = new Thread(obj_ThreadStart_DELEGACION);
                        obj_Thread_DELEGACION.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[2] = true;
                    }

                    //INV_MovimientosAlmacenLineas
                    ThreadStart obj_ThreadStart_MOVIMIENTOSALMACENLINEAS = new ThreadStart(Obtener_MovimientosAlmacenLineas_Modelo_Obtener);
                    Thread obj_Thread_MOVIMIENTOSALMACENLINEAS = new Thread(obj_ThreadStart_MOVIMIENTOSALMACENLINEAS);
                    obj_Thread_MOVIMIENTOSALMACENLINEAS.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_Empleado_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEEMPLEADOS_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idEmpleado };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.MAE_Empleados = (MAE_Empleados)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_Delegacion_ORIGEN_Modelo_Obtener()
        {
            try
            {
                g_dnm_Modelo_Obtener.GEN_Delegaciones = Datos_Generales.GEN_Delegaciones_Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idDelegacion_Origen);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        private void Obtener_Delegacion_DESTINO_Modelo_Obtener()
        {
            try
            {
                g_dnm_Modelo_Obtener.GEN_Delegaciones1 = Datos_Generales.GEN_Delegaciones_Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idDelegacion_Destino);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[2] = true;
            }
        }
        private void Obtener_MovimientosAlmacenLineas_Modelo_Obtener()
        {
            try
            {
                INV_MovimientosAlmacenLineas_Datos obj_INV_MovimientosAlmacenLineas_Datos = new INV_MovimientosAlmacenLineas_Datos();
                g_dnm_Modelo_Obtener.MovimientoAlmacenLineas = obj_INV_MovimientosAlmacenLineas_Datos.Obtener_MovimientoAlmacenLinea_PorCabecera(g_dnm_Modelo_Obtener.id);
            }
            finally
            {
                 g_bol_Hilos_Terminados_Obtener[3] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        
        public DateTime? Obtener_Fecha_PrimerInventario_Origen(long _lng_idArticulo, DateTime _dtt_Fecha,long _lng_idDelegacion,long _lng_idAlmacen, long? _lng_idUbicacion)
        {
            DateTime? dtt_FechaInventario = new DateTime(2900,31,12,23,59,59);

            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                         " SELECT Top 1 " +                          
                             nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fecha) + 
                        " FROM " + nameof(INV_MovimientosAlmacenCabecera) +
                        " INNER JOIN " + nameof(INV_MovimientosAlmacenLineas) + " ON " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.id) + "=" + nameof(INV_MovimientosAlmacenLineas) + "." + nameof(INV_MovimientosAlmacenLineas.idMovimientoAlmacenCabecera) +
                        " WHERE  " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fechaBorrado) + " IS null AND " +
                                     nameof(INV_MovimientosAlmacenLineas) + "." + nameof(INV_MovimientosAlmacenLineas.fechaBorrado) + " IS null AND " +
                                     nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fecha) + ">@fecha and  " +
                                     nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Origen) + "=@idDelegacion_Origen and  " +
                                      nameof(INV_MovimientosAlmacenLineas) + "." + nameof(INV_MovimientosAlmacenLineas.idArticulo) + "=@idArticulo and  " +
                                     nameof(INV_MovimientosAlmacenLineas) + "." + nameof(INV_MovimientosAlmacenLineas.idAlmacen_Origen) + "=@idAlmacen_Origen and  " +
                                     _lng_idUbicacion!=null ? (nameof(INV_MovimientosAlmacenLineas) + "." + nameof(INV_MovimientosAlmacenLineas.idUbicacion_Origen) + "=@idUbicacion_Origen ") : (nameof(INV_MovimientosAlmacenLineas) + "." + nameof(INV_MovimientosAlmacenLineas.idUbicacion_Origen) + " is null ") +
                        " ORDER BY " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fecha) + " ASC ";

                //Parametros
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                lst_Parametros.Add(new SqlParameter("@fecha", _dtt_Fecha));
                lst_Parametros.Add(new SqlParameter("@idDelegacion_Origen", _lng_idDelegacion));
                lst_Parametros.Add(new SqlParameter("@idArticulo", _lng_idArticulo));
                lst_Parametros.Add(new SqlParameter("@idAlmacen_Origen", _lng_idAlmacen));
                if (_lng_idUbicacion!=null)
                {
                    lst_Parametros.Add(new SqlParameter("@idUbicacion_Origen", _lng_idUbicacion.Value));
                }

                //Rellenar el Modelo
                DateTime? dtt_FechaInventario_AUX = obj_Exferia_Entities.Database.SqlQuery<DateTime>(str_SQL, lst_Parametros.ToArray()).FirstOrDefault();
                if (dtt_FechaInventario_AUX!=null)
                {
                    dtt_FechaInventario= dtt_FechaInventario_AUX;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Obtener_Fecha_PrimerInventario_Origen), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }


            return dtt_FechaInventario;
        }
        public DateTime? Obtener_Fecha_PrimerInventario_Destino(long _lng_idArticulo, DateTime _dtt_Fecha, long _lng_idDelegacion, long _lng_idAlmacen, long? _lng_idUbicacion)
        {
            DateTime? dtt_FechaInventario = new DateTime(2900, 31, 12, 23, 59, 59);

            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                         " SELECT Top 1 " +
                             nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fecha) +
                        " FROM " + nameof(INV_MovimientosAlmacenCabecera) +
                        " INNER JOIN " + nameof(INV_MovimientosAlmacenLineas) + " ON " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.id) + "=" + nameof(INV_MovimientosAlmacenLineas) + "." + nameof(INV_MovimientosAlmacenLineas.idMovimientoAlmacenCabecera) +
                        " WHERE  " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fechaBorrado) + " IS null AND " +
                                     nameof(INV_MovimientosAlmacenLineas) + "." + nameof(INV_MovimientosAlmacenLineas.fechaBorrado) + " IS null AND " +
                                     nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fecha) + ">@fecha and  " +
                                     nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Destino) + "=@idDelegacion_Destino and  " +
                                      nameof(INV_MovimientosAlmacenLineas) + "." + nameof(INV_MovimientosAlmacenLineas.idArticulo) + "=@idArticulo and  " +
                                     nameof(INV_MovimientosAlmacenLineas) + "." + nameof(INV_MovimientosAlmacenLineas.idAlmacen_Destino) + "=@idAlmacen_Destino and  " +
                                     _lng_idUbicacion != null ? (nameof(INV_MovimientosAlmacenLineas) + "." + nameof(INV_MovimientosAlmacenLineas.idUbicacion_Destino) + "=@idUbicacion_Destino ") : (nameof(INV_MovimientosAlmacenLineas) + "." + nameof(INV_MovimientosAlmacenLineas.idUbicacion_Destino) + " is null ") +
                        " ORDER BY " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.fecha) + " ASC ";

                //Parametros
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                lst_Parametros.Add(new SqlParameter("@fecha", _dtt_Fecha));
                lst_Parametros.Add(new SqlParameter("@idDelegacion_Destino", _lng_idDelegacion));
                lst_Parametros.Add(new SqlParameter("@idArticulo", _lng_idArticulo));
                lst_Parametros.Add(new SqlParameter("@idAlmacen_Destino", _lng_idAlmacen));
                if (_lng_idUbicacion != null)
                {
                    lst_Parametros.Add(new SqlParameter("@idUbicacion_Destino", _lng_idUbicacion.Value));
                }

                //Rellenar el Modelo
                DateTime? dtt_FechaInventario_AUX = obj_Exferia_Entities.Database.SqlQuery<DateTime>(str_SQL, lst_Parametros.ToArray()).FirstOrDefault();
                if (dtt_FechaInventario_AUX != null)
                {
                    dtt_FechaInventario = dtt_FechaInventario_AUX;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Obtener_Fecha_PrimerInventario_Destino), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }


            return dtt_FechaInventario;
        }

        #endregion

        #region MODELOS

        #region Modelo Simple
        private INV_MovimientosAlmacenCabecera g_mdl_INV_MovimientosAlmacenCabecera = null;

        public INV_MovimientosAlmacenCabecera Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                      //WHERE
                                      " WHERE " + nameof(INV_MovimientosAlmacenCabecera) + "." + nameof(INV_MovimientosAlmacenCabecera.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_INV_MovimientosAlmacenCabecera;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_INV_MovimientosAlmacenCabecera = obj_Exferia_Entities.Database.SqlQuery<INV_MovimientosAlmacenCabecera>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                     nameof(INV_MovimientosAlmacenCabecera.id) + "," +
                     nameof(INV_MovimientosAlmacenCabecera.numeroDocumento) + "," +
                     nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Origen) + "," +
                     nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Destino) + "," +
                     nameof(INV_MovimientosAlmacenCabecera.idEmpresa) + "," +
                     nameof(INV_MovimientosAlmacenCabecera.fecha) + "," +
                     nameof(INV_MovimientosAlmacenCabecera.guid) + "," +
                     nameof(INV_MovimientosAlmacenCabecera.fechaBorrado) + "," +
                     nameof(INV_MovimientosAlmacenCabecera.estado) + "," +
                     nameof(INV_MovimientosAlmacenCabecera.idEmpleado) + "," +
                     nameof(INV_MovimientosAlmacenCabecera.observaciones) +
                " FROM " + nameof(INV_MovimientosAlmacenCabecera);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();

                INV_MovimientosAlmacenCabecera mdl_INV_MovimientosAlmacenCabecera_AGrabar = (INV_MovimientosAlmacenCabecera)_mdl_obj;
                INV_MovimientosAlmacenCabecera mdl_INV_MovimientosAlmacenCabecera_DatosViejos = new INV_MovimientosAlmacenCabecera();

                // Ver si existe ######################################################################
                INV_MovimientosAlmacenCabecera mdl_INV_MovimientosAlmacenCabecera_Final = Obtener_Modelo_Por_Id(mdl_INV_MovimientosAlmacenCabecera_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_INV_MovimientosAlmacenCabecera_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_INV_MovimientosAlmacenCabecera_Final, mdl_INV_MovimientosAlmacenCabecera_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_INV_MovimientosAlmacenCabecera_AGrabar, mdl_INV_MovimientosAlmacenCabecera_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(INV_MovimientosAlmacenCabecera) +
                                           " SET " +
                                               nameof(INV_MovimientosAlmacenCabecera.numeroDocumento) + "=@numeroDocumento," +
                                               nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Origen) + "=@idDelegacion_Origen," +
                                               nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Destino) + "=@idDelegacion_Destino," +
                                               nameof(INV_MovimientosAlmacenCabecera.idEmpresa) + "=@idEmpresa," +
                                               nameof(INV_MovimientosAlmacenCabecera.fecha) + "=@fecha," +
                                               nameof(INV_MovimientosAlmacenCabecera.guid) + "=@guid," +
                                               nameof(INV_MovimientosAlmacenCabecera.fechaBorrado) + "=@fechaBorrado," +
                                               nameof(INV_MovimientosAlmacenCabecera.estado) + "=@estado," +
                                               nameof(INV_MovimientosAlmacenCabecera.idEmpleado) + "=@idEmpleado," +
                                               nameof(INV_MovimientosAlmacenCabecera.observaciones) + "=@observaciones" +
                                           " WHERE " +
                                               nameof(INV_MovimientosAlmacenCabecera.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                         new SqlParameter("@numeroDocumento",  mdl_INV_MovimientosAlmacenCabecera_Final.numeroDocumento),
                         new SqlParameter("@idDelegacion_Origen",  mdl_INV_MovimientosAlmacenCabecera_Final.idDelegacion_Origen),
                         new SqlParameter("@idDelegacion_Destino",  mdl_INV_MovimientosAlmacenCabecera_Final.idDelegacion_Destino),
                         new SqlParameter("@idEmpresa",  mdl_INV_MovimientosAlmacenCabecera_Final.idEmpresa),
                         new SqlParameter("@fecha",  mdl_INV_MovimientosAlmacenCabecera_Final.fecha),
                         mdl_INV_MovimientosAlmacenCabecera_Final.guid!=null
                            ?   new SqlParameter("@guid", mdl_INV_MovimientosAlmacenCabecera_Final.guid)
                            :   new SqlParameter("@guid",  DBNull.Value),
                         mdl_INV_MovimientosAlmacenCabecera_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_INV_MovimientosAlmacenCabecera_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         mdl_INV_MovimientosAlmacenCabecera_Final.estado!=null
                            ?   new SqlParameter("@estado", mdl_INV_MovimientosAlmacenCabecera_Final.estado)
                            :   new SqlParameter("@estado",  DBNull.Value),
                         mdl_INV_MovimientosAlmacenCabecera_Final.idEmpleado!=null
                            ?   new SqlParameter("@idEmpleado", mdl_INV_MovimientosAlmacenCabecera_Final.idEmpleado.Value)
                            :   new SqlParameter("@idEmpleado",  DBNull.Value),
                         mdl_INV_MovimientosAlmacenCabecera_Final.observaciones!=null
                            ?   new SqlParameter("@observaciones", mdl_INV_MovimientosAlmacenCabecera_Final.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value),
                         new SqlParameter("@id",  mdl_INV_MovimientosAlmacenCabecera_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_INV_MovimientosAlmacenCabecera_Final.id;
                }
                //INSERT
                else
                {
                    mdl_INV_MovimientosAlmacenCabecera_Final = new INV_MovimientosAlmacenCabecera();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_INV_MovimientosAlmacenCabecera_AGrabar, mdl_INV_MovimientosAlmacenCabecera_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(INV_MovimientosAlmacenCabecera) +
                                              " (" +
                                                      nameof(INV_MovimientosAlmacenCabecera.numeroDocumento) + "," +
                                                      nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Origen) + "," +
                                                      nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Destino) + "," +
                                                      nameof(INV_MovimientosAlmacenCabecera.idEmpresa) + "," +
                                                      nameof(INV_MovimientosAlmacenCabecera.fecha) + "," +
                                                      nameof(INV_MovimientosAlmacenCabecera.guid) + "," +
                                                      nameof(INV_MovimientosAlmacenCabecera.fechaBorrado) + "," +
                                                      nameof(INV_MovimientosAlmacenCabecera.estado) + "," +
                                                      nameof(INV_MovimientosAlmacenCabecera.idEmpleado) + "," +
                                                      nameof(INV_MovimientosAlmacenCabecera.observaciones) + 
                                              " ) " +
                                              " OUTPUT INSERTED." + nameof(INV_MovimientosAlmacenCabecera.id) +
                                              " VALUES " +
                                              " ( " +
                                                  "@numeroDocumento," +
                                                  "@idDelegacion_Origen," +
                                                  "@idDelegacion_Destino," +
                                                  "@idEmpresa," +
                                                  "@fecha," +
                                                  "@guid," +
                                                  "@fechaBorrado," +
                                                  "@estado," +
                                                  "@idEmpleado," +
                                                  "@observaciones" +
                                              " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@numeroDocumento",  mdl_INV_MovimientosAlmacenCabecera_Final.numeroDocumento),
                         new SqlParameter("@idDelegacion_Origen",  mdl_INV_MovimientosAlmacenCabecera_Final.idDelegacion_Origen),
                         new SqlParameter("@idDelegacion_Destino",  mdl_INV_MovimientosAlmacenCabecera_Final.idDelegacion_Destino),
                         new SqlParameter("@idEmpresa",  mdl_INV_MovimientosAlmacenCabecera_Final.idEmpresa),
                         new SqlParameter("@fecha",  mdl_INV_MovimientosAlmacenCabecera_Final.fecha),
                         mdl_INV_MovimientosAlmacenCabecera_Final.guid!=null
                            ?   new SqlParameter("@guid", mdl_INV_MovimientosAlmacenCabecera_Final.guid)
                            :   new SqlParameter("@guid",  DBNull.Value),
                         mdl_INV_MovimientosAlmacenCabecera_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_INV_MovimientosAlmacenCabecera_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         mdl_INV_MovimientosAlmacenCabecera_Final.estado!=null
                            ?   new SqlParameter("@estado", mdl_INV_MovimientosAlmacenCabecera_Final.estado)
                            :   new SqlParameter("@estado",  DBNull.Value),
                         mdl_INV_MovimientosAlmacenCabecera_Final.idEmpleado!=null
                            ?   new SqlParameter("@idEmpleado", mdl_INV_MovimientosAlmacenCabecera_Final.idEmpleado.Value)
                            :   new SqlParameter("@idEmpleado",  DBNull.Value),
                         mdl_INV_MovimientosAlmacenCabecera_Final.observaciones!=null
                            ?   new SqlParameter("@observaciones", mdl_INV_MovimientosAlmacenCabecera_Final.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(INV_MovimientosAlmacenCabecera), mdl_INV_MovimientosAlmacenCabecera_DatosViejos, mdl_INV_MovimientosAlmacenCabecera_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Insertar(INV_MovimientosAlmacenCabecera _mdl_INV_MovimientosAlmacenCabecera)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();

                INV_MovimientosAlmacenCabecera mdl_INV_MovimientosAlmacenCabecera_DatosViejos = new INV_MovimientosAlmacenCabecera();
                INV_MovimientosAlmacenCabecera mdl_INV_MovimientosAlmacenCabecera_Final = new INV_MovimientosAlmacenCabecera();

                //Tipo de Accion que se va a realizar
                mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                // Cargar los Datos del Modelo
                Funciones.CopiarPropiedadesObjetos(_mdl_INV_MovimientosAlmacenCabecera, mdl_INV_MovimientosAlmacenCabecera_Final, false, false);

                #region INSERT
                string str_SQL_Insert = " INSERT INTO " + nameof(INV_MovimientosAlmacenCabecera) +
                                            " (" +
                                                    nameof(INV_MovimientosAlmacenCabecera.numeroDocumento) + "," +
                                                    nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Origen) + "," +
                                                    nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Destino) + "," +
                                                    nameof(INV_MovimientosAlmacenCabecera.idEmpresa) + "," +
                                                    nameof(INV_MovimientosAlmacenCabecera.fecha) + "," +
                                                    nameof(INV_MovimientosAlmacenCabecera.guid) + "," +
                                                    nameof(INV_MovimientosAlmacenCabecera.fechaBorrado) + "," +
                                                    nameof(INV_MovimientosAlmacenCabecera.estado) + "," +
                                                    nameof(INV_MovimientosAlmacenCabecera.idEmpleado) + "," +
                                                    nameof(INV_MovimientosAlmacenCabecera.observaciones) +
                                            " ) " +
                                            " OUTPUT INSERTED." + nameof(INV_MovimientosAlmacenCabecera.id) +
                                            " VALUES " +
                                            " ( " +
                                                "@numeroDocumento," +
                                                "@idDelegacion_Origen," +
                                                "@idDelegacion_Destino," +
                                                "@idEmpresa," +
                                                "@fecha," +
                                                "@guid," +
                                                "@fechaBorrado," +
                                                "@estado," +
                                                "@idEmpleado," +
                                                "@observaciones" +
                                            " ) ";

                //Parametros
                object[] arr_Parametros_Insert = new object[]
                {
                    new SqlParameter("@numeroDocumento",  mdl_INV_MovimientosAlmacenCabecera_Final.numeroDocumento),
                        new SqlParameter("@idDelegacion_Origen",  mdl_INV_MovimientosAlmacenCabecera_Final.idDelegacion_Origen),
                        new SqlParameter("@idDelegacion_Destino",  mdl_INV_MovimientosAlmacenCabecera_Final.idDelegacion_Destino),
                        new SqlParameter("@idEmpresa",  mdl_INV_MovimientosAlmacenCabecera_Final.idEmpresa),
                        new SqlParameter("@fecha",  mdl_INV_MovimientosAlmacenCabecera_Final.fecha),
                        mdl_INV_MovimientosAlmacenCabecera_Final.guid!=null
                        ?   new SqlParameter("@guid", mdl_INV_MovimientosAlmacenCabecera_Final.guid)
                        :   new SqlParameter("@guid",  DBNull.Value),
                        mdl_INV_MovimientosAlmacenCabecera_Final.fechaBorrado!=null
                        ?   new SqlParameter("@fechaBorrado", mdl_INV_MovimientosAlmacenCabecera_Final.fechaBorrado.Value)
                        :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        mdl_INV_MovimientosAlmacenCabecera_Final.estado!=null
                        ?   new SqlParameter("@estado", mdl_INV_MovimientosAlmacenCabecera_Final.estado)
                        :   new SqlParameter("@estado",  DBNull.Value),
                        mdl_INV_MovimientosAlmacenCabecera_Final.idEmpleado!=null
                        ?   new SqlParameter("@idEmpleado", mdl_INV_MovimientosAlmacenCabecera_Final.idEmpleado.Value)
                        :   new SqlParameter("@idEmpleado",  DBNull.Value),
                        mdl_INV_MovimientosAlmacenCabecera_Final.observaciones!=null
                        ?   new SqlParameter("@observaciones", mdl_INV_MovimientosAlmacenCabecera_Final.observaciones)
                        :   new SqlParameter("@observaciones",  DBNull.Value)
                };
                #endregion

                //Id de la tabla
                mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();

                #region TABLAS RELACIONADAS
                //LINEAS
                if (_mdl_INV_MovimientosAlmacenCabecera.INV_MovimientosAlmacenLineas != null && _mdl_INV_MovimientosAlmacenCabecera.INV_MovimientosAlmacenLineas.Count > 0)
                {
                    INV_MovimientosAlmacenLineas_Datos obj_INV_MovimientosAlmacenLineas_Datos = new INV_MovimientosAlmacenLineas_Datos();

                    foreach (INV_MovimientosAlmacenLineas mdl_INV_MovimientosAlmacenLineas in _mdl_INV_MovimientosAlmacenCabecera.INV_MovimientosAlmacenLineas)
                    {
                        //Añadir el idMovimientoAlmacenCabecera
                        mdl_INV_MovimientosAlmacenLineas.idMovimientoAlmacenCabecera = mdl_INTERNO_ValorDevuelto_Modelo.Id;

                        //Insertar
                        obj_INV_MovimientosAlmacenLineas_Datos.Insertar(mdl_INV_MovimientosAlmacenCabecera_Final,mdl_INV_MovimientosAlmacenLineas);
                    }
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Actualizar_Estado(long _lng_id,string _str_Estado)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();

                string str_SQL_Update =
                    " UPDATE " + nameof(INV_MovimientosAlmacenCabecera) +
                    "   set " + nameof(INV_MovimientosAlmacenCabecera.estado) + "='" + _str_Estado + "' " +
                    " WHERE " + nameof(INV_MovimientosAlmacenCabecera.id) + "=" + _lng_id;

                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Actualizar_Estado), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public INTERNO_ValorDevuelto_Modelo Actualizar_Fecha(long _lng_id, DateTime _dtt_Fecha)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();

                string str_SQL_Update =
                    " UPDATE " + nameof(INV_MovimientosAlmacenCabecera) +
                    "   set " +
                            nameof(INV_MovimientosAlmacenCabecera.fecha) + "='" + _dtt_Fecha.ToString("dd/MM/yyyy") + "' " +
                    " WHERE " + nameof(INV_MovimientosAlmacenCabecera.id) + "=" + _lng_id;

                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Actualizar_Fecha), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public INTERNO_ValorDevuelto_Modelo Actualizar_Delegacion_Origen(long _lng_id, long _lng_idDelegacion)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL_Update =
                    " UPDATE " + nameof(INV_MovimientosAlmacenCabecera) +
                    "   set " +
                            nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Origen) + "=" + _lng_idDelegacion +
                    " WHERE " + nameof(INV_MovimientosAlmacenCabecera.id) + "=" + _lng_id;

                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update);
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Actualizar_Delegacion_Origen), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public INTERNO_ValorDevuelto_Modelo Actualizar_Delegacion_Destino(long _lng_id, long _lng_idDelegacion)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL_Update =
                    " UPDATE " + nameof(INV_MovimientosAlmacenCabecera) +
                    "   set " +
                            nameof(INV_MovimientosAlmacenCabecera.idDelegacion_Destino) + "=" + _lng_idDelegacion +
                    " WHERE " + nameof(INV_MovimientosAlmacenCabecera.id) + "=" + _lng_id;

                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update);
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Actualizar_Delegacion_Destino), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;
            bool bol_ActualizarFechaBorrado = false;//Este campo se utiliza por si no se puede borrar, que actualice la fecha de borrado

            using (TransactionScope transaccion_SQL = new TransactionScope(TransactionScopeOption.Required))
            {
                try
                {
                    obj_Exferia_Entities = new Exferia_Entities();
                    obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                    // Ver si existe ######################################################################
                    INV_MovimientosAlmacenCabecera mdl_INV_MovimientosAlmacenCabecera_Final = Obtener_Modelo_Por_Id(_lng_id);
                    //######################################################################################

                    INV_MovimientosAlmacenLineas_Datos obj_INV_MovimientosAlmacenLineas_Datos = new INV_MovimientosAlmacenLineas_Datos();

                    if (mdl_INV_MovimientosAlmacenCabecera_Final != null)
                    {
                        //Se intenta borrar, si diera un error porque esta relacaionado se graba la fecha de baja
                        try
                        {
                            //Quitar el IdMovimientosAlmacenCabecera de la tabla de INV_MovimientosAlmacenCabecera
                            obj_INV_MovimientosAlmacenLineas_Datos.Quitar_Por_idMovimientoAlmacenCabecera(_lng_id, mdl_INV_MovimientosAlmacenCabecera_Final.fecha, mdl_INV_MovimientosAlmacenCabecera_Final.idDelegacion_Origen, mdl_INV_MovimientosAlmacenCabecera_Final.idDelegacion_Destino);

                            #region Delete
                            string str_SQL_Delete = " DELETE FROM  " + nameof(INV_MovimientosAlmacenCabecera) +
                                                    " WHERE " +
                                                        nameof(INV_MovimientosAlmacenCabecera.id) + "=@id";
                            //Parametros
                            object[] arr_Parametros_Delete = new object[]
                            {
                                new SqlParameter("@id", _lng_id)
                            };
                            #endregion

                            //Delete
                            obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                            //Grabar un registro de trazabailidad con los datos de la transaccion realizada.
                            Datos_Generales.USR_Trazabilidad_Grabar(typeof(INV_MovimientosAlmacenCabecera), null, mdl_INV_MovimientosAlmacenCabecera_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                        }
                        catch (Exception ex)
                        {
                            var sqlException = ex.GetBaseException() as SqlException;
                            if (sqlException != null)
                            {
                                if (sqlException.Errors.Count > 0)
                                {
                                    switch (sqlException.Errors[0].Number)
                                    {
                                        case Control_Errores.G_INT_ERRORCONTROLADO_BORRAR_CONFLICTO_CLAVEFORANEA: // Foreign Key violation
                                            bol_ActualizarFechaBorrado = true;
                                            break;
                                        default:
                                            throw;
                                    }
                                }
                            }
                            else
                            {
                                throw;
                            }
                        }

                        //Actualizar la fecha de baja, al no poder borrarlo por tener relaciones
                        if (bol_ActualizarFechaBorrado)
                        {
                            #region Update
                            string str_SQL_Update = " UPDATE " + nameof(INV_MovimientosAlmacenCabecera) +
                                                        " SET " +
                                                        nameof(INV_MovimientosAlmacenCabecera.fechaBorrado) + "=@fechaBorrado " +
                                                    " WHERE " +
                                                        nameof(INV_MovimientosAlmacenCabecera.id) + "=@id";
                            //Parametros
                            object[] arr_Parametros_Update = new object[]
                            {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                new SqlParameter("@id", _lng_id)
                            };
                            #endregion

                            //Update
                            obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                            //Grabar un registro de trazabilidad con los datos de la trasaccion realizada
                            Datos_Generales.USR_Trazabilidad_Grabar(typeof(INV_MovimientosAlmacenCabecera), null, mdl_INV_MovimientosAlmacenCabecera_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                        }
                    }

                    // Devolver también el Objeto
                    mdl_ValorDevuelto_Modelo.Id = _lng_id;

                    // Se termina la Transaccion Correctamente
                    transaccion_SQL.Complete();
                }
                catch (Control_Errores)
                {
                    throw;
                }
                catch (Exception ex)
                {
                    throw new Control_Errores("", ex, nameof(INV_MovimientosAlmacenCabecera_Datos) + "/" + nameof(Borrar), true);
                }
                finally
                {
                    obj_Exferia_Entities.Database.Connection.Close();
                    obj_Exferia_Entities.Dispose();

                    // Finalizar transaccion
                    transaccion_SQL.Dispose();
                }
            }
            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            return null;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
